<template>
  <aside class="navside">
    <div class="navside__header is-hidden-mobile"></div>
    <div class="navside__profile">
      <AUserAvatar :user-name="fullName" :avatar-url="avatarUrl"></AUserAvatar>
    </div>
    <div class="navside__content">
      <aside class="menu">
        <p class="menu-label has-text-light">General</p>
        <ul class="menu-list">
          <div v-if="authenticated">
            <li v-if="has_projects" class="navside__nav-item">
              <router-link
                tag="a"
                :to="{name: 'dashboard-project', params: {projectUUID: active_project.uuid}}"
                active-class="is-active"
              >Dashboard</router-link>
            </li>
            <li v-else class="navside__nav-item">
              <router-link
                tag="a"
                :to="{name: 'dashboard-add_project'}"
                active-class="is-active"
              >Add Project</router-link>
            </li>
            <li v-if="arbaloAdmin" class="navside__nav-item">
              <router-link
                tag="a"
                :to="{name: 'service-register'}"
                active-class="is-active"
              >Add Service</router-link>
            </li>
          </div>
          <li class="navside__nav-item">
            <router-link tag="a" :to="{name: 'about'}" active-class="is-active">About</router-link>
          </li>
        </ul>

        <p class="menu-label has-text-light">Services</p>
        <ul class="menu-list">
          <li class="navside__nav-item">
            <router-link
              tag="a"
              :to="{name: 'service-catalog'}"
              active-class="is-active"
            >Service Catalog</router-link>
          </li>
        </ul>

        <p class="menu-label has-text-light">Account</p>
        <div v-if="authenticated">
          <ul class="menu-list">
            <li class="navside__nav-item">
              <a v-on:click="accountManagement">User Settings</a>
            </li>
            <li class="navside__nav-item">
              <a v-on:click="logout">Logout</a>
            </li>
          </ul>
        </div>
        <div v-else>
          <ul class="menu-list">
            <li class="navside__nav-item">
              <a v-on:click="login">Login</a>
            </li>
          </ul>
        </div>
      </aside>
    </div>
  </aside>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import { KeycloakProfile } from "keycloak-js";
import AUserAvatar from "@/components/AUserAvatar.vue";
import AnArbaloLogo from "@/components/AnArbaloLogo.vue";
import { Project } from "../services/arbalo_extensions/projects";
import _ from "lodash";
import { isArbaloAdmin } from "../keycloak";

@Component({
  components: {
    AUserAvatar,
    AnArbaloLogo
  }
})
export default class TheSidebar extends Vue {
  accountManagement() {
    this.$keycloak.accountManagement();
  }

  logout() {
    this.$keycloak.logout();
  }

  login() {
    // this.$keycloak.login({ redirectUri: this.$router.currentRoute.fullPath });
    this.$keycloak.login();
  }

  get authenticated(): boolean {
    return this.$keycloak.authenticated ? true : false;
  }

  get arbaloAdmin(): boolean {
    return isArbaloAdmin();
  }

  get fullName(): string {
    let profile: KeycloakProfile = this.$store.state.user.keycloakProfile;
    if (profile) {
      return profile.firstName + " " + profile.lastName;
    }
    return "Anonymous";
  }

  get avatarUrl(): string {
    return _.get(this.$store.state.user, "arbaloProfile.avatar_url");
  }

  get has_projects(): boolean {
    return this.$store.state.projects.length > 0;
  }

  get active_project(): Project {
    return this.$store.state.activeProject;
  }
}
</script>

<style lang="scss" scoped>
.navside {
  grid-area: navside;
  color: white;
  background-color: $navbar-side-colour;
  box-shadow: 0 2px 2px 0 rgba(0, 0, 0, 0.16), 0 0 0 1px rgba(0, 0, 0, 0.08);
  height: 100%;

  // Fixed position, off screen to "hide" Navbar
  position: fixed;
  transform: translateX(-$navbar-side-width);

  // For "sliding" in
  transition: all 0.4s ease-in-out;
  z-index: 2; /* Needs to sit above the hamburger menu icon */

  display: grid;
  grid-template-columns: 1fr;
  grid-template-rows: $navbar-header-height $navbar-header-height * 3 1fr;
  grid-template-areas:
    "navside-header"
    "navside-profile"
    "navside-content";

  &__header {
    grid-area: navside-header;
    display: flex;
    align-items: center;
    justify-content: center;

    padding: 0 20px;
  }

  &__profile {
    grid-area: navside-profile;
    display: flex;
    align-items: center;

    padding: 0 20px;

    background-color: $blue;
  }

  &__content {
    grid-area: navside-content;
    padding: 1.5em;
  }

  &__service-provider {
  }

  &__nav-item a {
    color: white;

    &:hover {
      color: $green;
    }
  }

  &.active {
    transform: translateX(0);
  }

  @include media(">tablet") {
    // When screen is big enough, show Navbar
    position: relative;
    transform: translateX(0);
  }
}
</style>
